﻿#include "stdafx.h"
#include "DuiDefine.h"
#include "Resource.h"
#include "..\..\DuiLib\Utils\WinImplBase.h"
#include "CreateNewGroupWnd.h"

#define kEditGroupName _T("edit_group_name")
#define kSettingOk		_T("setting_ok")
#define kSettingCancel  _T("setting_cancel")
#define kSettingClose  _T("closebtn")

#define RE_DISABLE_COLOR	RGB(0xb7,0xb8,0xc4)
#define RE_NORMAL_COLOR		RGB(0x80,0x80,0x89)

#define SetControlResourceText(name,id)\
	{CControlUI *p = static_cast<CControlUI*>(m_PaintManager.FindControl(name));  \
	if (p)p->SetText(LoadStringFromResource(id));}

#define SetControlText(name,txt)\
	{CControlUI *p = static_cast<CControlUI*>(m_PaintManager.FindControl(name));  \
	if (p)p->SetText(txt);}


DUI_BEGIN_MESSAGE_MAP(CCreateNewGroupWnd, WindowImplBase, FALSE)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_WINDOWINIT, OnPrepare)
	DUI_ON_CLICK_CTRNAME(kSettingOk,OnOkButtonClick)
	DUI_ON_CLICK_CTRNAME(kSettingCancel,OnSettingClose)
	DUI_ON_CLICK_CTRNAME(kSettingClose,OnSettingClose)
DUI_END_MESSAGE_MAP()

DUI_BEGIN_CUSTOM_MSG_MAP(CCreateNewGroupWnd)
DUI_END_CUSTOM_MSG_MAP()



CCreateNewGroupWnd::CCreateNewGroupWnd(HWND hParentWnd)
{
	m_nNewGroupID = 0;
	Create(hParentWnd, _T("CreateNewGroupWnd"), WS_POPUPWINDOW, WS_EX_DLGMODALFRAME, CRect(0, 0, 270, 175));
	CenterWindow();
	g_pMessengerActor->RegisterObserver(this);
}

CCreateNewGroupWnd::~CCreateNewGroupWnd()
{
	g_pMessengerActor->UnRegisterObserver(this);
}

bool CCreateNewGroupWnd::OnGTMessengerActor_ResponseBuddyGroupAction(IGTMessengerActor *pActor, const GT_BUDDY_GROUP_RESULT_DATA& sData, GTBuddyAddGroupType addGroupType)
{
	switch (sData.eAction)
	{
	case buddyGroupAction_Add:
		if( addGroupType != buddyGroupAction_OrgChart )
			break;

		if (sData.eError == buddyGroupError_None)
		{
			m_nNewGroupID = sData.nGroupID;
			Close(IDOK);
		}
		else
		{
			// CNeMessengerDlg俊辑 鞍篮 妮归阑 罐绊 乐促.
			// 弊缝 眠啊 角菩矫 2焙单狼 窃荐啊 悼矫俊 龋免登绊, 
			// 皋矫瘤 冠胶档 滴俺啊 躲 荐 乐扁 锭巩俊 咯扁俊辑绰 剁快瘤 臼绰促.
		}
		break;

	default:
		break;
	}

	return true;
}

void CCreateNewGroupWnd::InitWindow()
{
	SetControlResourceText(kSettingOk,IDS_STRING568);
	SetControlResourceText(kSettingCancel,IDS_STRING569);
	SetControlResourceText(_T("title_name"), IDS_STRING262);
	SetControlResourceText(_T("lbl_autotext"),IDS_STRING570);

	CEditUI* pEditGroupName = static_cast<CEditUI*>(m_PaintManager.FindControl(kEditGroupName));
	ASSERT(pEditGroupName != NULL);
	pEditGroupName->SetFocus();
}


LPCTSTR CCreateNewGroupWnd::GetWindowClassName() const
{
	return _T("SettingAutoTextPopup");
}

void CCreateNewGroupWnd::OnOkButtonClick(TNotifyUI& msg)
{
	CString strFavoriteName = _T("");
	CEditUI* pEditGroupName = static_cast<CEditUI*>(m_PaintManager.FindControl(kEditGroupName));
	ASSERT(pEditGroupName != NULL);
	strFavoriteName = pEditGroupName->GetText();
	strFavoriteName.Trim();

	CString strMessage;
	const IGTBuddyGroup* pBuddyGroup = g_pMessengerActor->GetBuddyGroupInfo(strFavoriteName);
	if( pBuddyGroup != NULL )
	{
		strMessage.LoadString(IDS_STRING253);
		NMessageBox(CWnd::FromHandle(m_hWnd), strMessage);
		return;
	}

	if (strFavoriteName.IsEmpty())
	{
		NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING265));	// 积己且 弊缝疙阑 涝仿秦 林技夸.
		return;
	}

	if(g_pMessengerActor->GetBuddyGroupCount() >= MAX_GROUP)
	{	
		CString strMaxGroupCnt;
		strMaxGroupCnt.Format(IDS_STRING227, MAX_GROUP);
		NMessageBox(CWnd::FromHandle(m_hWnd), strMaxGroupCnt);
		return;
	}

	if (g_pMessengerActor->RequestAddBuddyGroup(strFavoriteName, buddyGroupAction_OrgChart) == false)
	{
		NTALK_LOG->Debug(L"[BUDDY] RequestAddBuddyGroup(%s, %d) Failed", strFavoriteName, buddyGroupAction_OrgChart);
		NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING266));
	}
	else
	{
		NTALK_LOG->Debug(L"[BUDDY] RequestAddBuddyGroup(%s, %d) Succeeded", strFavoriteName, buddyGroupAction_OrgChart);
	}
}

void CCreateNewGroupWnd::OnSettingClose(TNotifyUI& msg)
{
	
	Close(IDCANCEL);
}

void CCreateNewGroupWnd::OnPrepare(TNotifyUI& msg)
{
// 	if (m_pRichEdit)
// 	{
// 		m_pRichEdit->SetFocus();
// 	}
}

 
CDuiString CCreateNewGroupWnd::GetSkinFile()
{
	return _T("create_new_group.xml");
}

CDuiString CCreateNewGroupWnd::GetSkinFolder()
{
	return _T("skin\\nTalkRes");
}





